SystemOrganization addCategory: #'TADP-The-Blob'!

Object subclass: #BlendedClassFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-The-Blob'!

!BlendedClassFinder methodsFor: 'as yet unclassified' stamp: 'Tiziano 5/1/2013 19:58'!
findAttributes: unaClase

	^(unaClase instVarNames) asSet

	! !

!BlendedClassFinder methodsFor: 'as yet unclassified' stamp: 'Tiziano 5/2/2013 23:20'!
findMethodAttributes: unMetodo withClassAttributes: atributos 
| methodAttributes |

	methodAttributes := Set new.
	
	atributos do: [:unAtributo | (unMetodo usesInstVarNamed: unAtributo) ifTrue: [methodAttributes add: unAtributo]].
	
	^methodAttributes

	! !

!BlendedClassFinder methodsFor: 'as yet unclassified' stamp: 'Tiziano 5/1/2013 18:10'!
findMethods: unaClase

	^(unaClase methodDictionary) asSet

	! !

!BlendedClassFinder methodsFor: 'as yet unclassified' stamp: 'Tiziano 5/2/2013 22:13'!
separateClass: unaClase
| metodos clasesSeparadas coleccionAtributosClasesNuevas atributos atributosCoincidentes atributosDeMetodo numeroDeClases clasesAFusionar |

	numeroDeClases := 0.
	metodos := self findMethods: unaClase.
	atributos := self findAttributes: unaClase.
	clasesSeparadas := OrderedCollection new.
	clasesSeparadas add: SeparatedClass newInitialized.
	
	metodos do: [:unMetodo | 
			atributosDeMetodo :=(self findMethodAttributes: unMetodo withClassAttributes: atributos).
			clasesSeparadas do: [:claseSeparada | 				
					atributosCoincidentes := (atributosDeMetodo intersection: claseSeparada getAttributes). 			
					atributosCoincidentes size > 0 ifTrue: [
						claseSeparada getAttributes add: atributosDeMetodo.
						claseSeparada getMethods add: unMetodo.
						numeroDeClases := numeroDeClases + 1]].
			"Esta parte se fija si el metodo no fue agregado, y entonces agrega una nueva clase para agregarlo;
			o se fija si fue agregado a ms de una clase, y entonces fusiona las clases."
			numeroDeClases = 0 ifTrue: [
				clasesSeparadas add: SeparatedClass newInitialized.
				clasesSeparadas last getAttributes add: atributosDeMetodo.
				clasesSeparadas last getMethods add: unMetodo.] 
			ifFalse: [numeroDeClases > 1 ifTrue: [
				clasesAFusionar := clasesSeparadas select: [:clase | clase getMethods includes: unMetodo].
				clasesSeparadas remove: clasesAFusionar.
				clasesSeparadas add: SeparatedClass newInitialized.
				clasesAFusionar do: [:claseAFusionar | 				
						clasesSeparadas last getAttributes add: claseAFusionar getAttributes .
						clasesSeparadas last getMethods add: claseAFusionar getMethods.]]]
			numeroDeClases = 0].
		
	^clasesSeparadas

	! !

!BlendedClassFinder methodsFor: 'as yet unclassified' stamp: 'Tiziano 5/2/2013 22:15'!
verifyClass: unaClase
| clasesSeparadas |

	clasesSeparadas := self separateClass: unaClase.
		
	^clasesSeparadas size >  1 ifTrue: [^'La clase puede separarse.'] ifFalse: [^'La clase no puede separarse.']

	! !

Object subclass: #SeparatedClass
	instanceVariableNames: 'attributes methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-The-Blob'!

!SeparatedClass class methodsFor: 'as yet unclassified' stamp: 'Tiziano 5/2/2013 22:26'!
newInitialized
| separatedClass |

	separatedClass := SeparatedClass new.
	separatedClass setMethods: Set new.
	separatedClass setAttributes: Set new.
	! !

!SeparatedClass methodsFor: 'as yet unclassified' stamp: 'Tiziano 5/1/2013 17:57'!
getAttributes

	^attributes! !

!SeparatedClass methodsFor: 'as yet unclassified' stamp: 'Tiziano 5/1/2013 17:57'!
getMethods

	^methods! !

!SeparatedClass methodsFor: 'as yet unclassified' stamp: 'Tiziano 5/1/2013 17:35'!
setAttributes: coleccionDeAtributos

	attributes := coleccionDeAtributos ! !

!SeparatedClass methodsFor: 'as yet unclassified' stamp: 'Tiziano 5/1/2013 17:36'!
setMethods: coleccionDeMetodos

	methods := coleccionDeMetodos ! !
